package wafly.framework.storyTK;

import java.util.ArrayList;

import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.control.Button;
import wafly.framework.storyTK.tmpl.OperationalControl;
import wafly.framework.storyTK.tmpl.OperationalControl.Status;
import android.app.Activity;
import android.content.Context;
import android.content.pm.ActivityInfo;
import android.content.res.Configuration;
import android.graphics.Rect;
import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaPlayer.OnPreparedListener;
import android.os.Bundle;
import android.os.Handler;
import android.os.PowerManager;
import android.os.PowerManager.WakeLock;
import android.view.KeyEvent;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.AbsoluteLayout;

/**
 * Should being extended by your Activity, it will complete the tasks of an Activity and you only need to "init" your allpication and start.
 * @author Wafly
 */
@SuppressWarnings("deprecation")
public abstract class STK extends Activity
{
	private boolean isStarted=false;
	private WakeLock wakeLock = null; 
	static SurfaceHolder videoViewHolder=null;
	ArrayList<Integer> keysPressed = new ArrayList<Integer>();
	private boolean keyDownResult=false;
	AbsoluteLayout layout = null;
	SurfaceView videoView = null;
	Handler videoViewHandler = null;
	
	static int touchRelaX=0, touchRelaY=0;
    
	/**
	 * Init your application here. <br>
	 * Please do not use Arena as it is not init yet at this time
	 */
	protected abstract void init();
	
	/**
	 * Start your application here, it will create a new thread. <br>
	 * Please di not out your init code here as the Arena already started.
	 */
	protected abstract void perform();

	@Override
	public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
        	this.wakeLock = ((PowerManager)this.getSystemService(Context.POWER_SERVICE)).newWakeLock(PowerManager.FULL_WAKE_LOCK, "StoryToolKitLock");
        } catch (Exception e) { }
        if(Util.isVideoEnable()){
        	videoViewHandler = new Handler();
        }
	}

	@Override
	protected void onStart()
	{
		super.onStart();
		init();
		Arena.drawSourceRect = new Rect(0,0,Util.getGameWidth(), Util.getGameHeight());
		if(Util.getScreenDirection()==1) {
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		} else if(getResources().getConfiguration().orientation != Configuration.ORIENTATION_LANDSCAPE) {
			setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
			return;
		}
		getWindow().addFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN);
//		getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		layout = new AbsoluteLayout(this);

		setContentView(layout);

		layout.addView(new Arena(this));
		
		if (Util.isVideoEnable())
		{
			videoView = new SurfaceView(this){
				protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
					setMeasuredDimension(this.getWidth(), this.getHeight());
				}
			};
			layout.addView(videoView);
			videoViewHolder = videoView.getHolder();
			videoViewHolder.addCallback(new SurfaceHolder.Callback() {
				public void surfaceCreated(SurfaceHolder holder) { }

				public void surfaceChanged(SurfaceHolder holder, int format, int width, int height) {
					switch (Util.getDisplayMode())
					{
//					case ORIGINAL:
//						videoView.setLayoutParams(new AbsoluteLayout.LayoutParams(Util.getGameWidth(), Util.getGameHeight(), 0, 0));
//						break;
					case ORIGINAL:
						videoView.setLayoutParams(new AbsoluteLayout.LayoutParams(Util.getGameWidth(), Util.getGameHeight(),
								(width - Util.getGameWidth()) / 2, (height - Util.getGameHeight()) / 2));
						break;
					case ZOOM:
						int x = 0, y = 0, distWidth = width, distHeight = height;
						if ((float) distWidth / (float) distHeight > (float) Util.getGameWidth() / (float) Util.getGameHeight())
						{
							distWidth = (int) (distHeight * (float) Util.getGameWidth() / (float) Util.getGameHeight());
							x = (Arena.getInstance().getWidth() - distWidth) / 2;
						}
						else
						{
							distHeight = (int) (distWidth * (float) Util.getGameHeight() / (float) Util.getGameWidth());
							y = (Arena.getInstance().getHeight() - distHeight) / 2;
						}
						videoView.setLayoutParams(new AbsoluteLayout.LayoutParams(distWidth, distHeight, x, y));
						break;
					case STRETCH:
						videoView.setLayoutParams(new AbsoluteLayout.LayoutParams(width, height, 0, 0));
						videoViewHolder.setFixedSize(width, height);
						break;
					}
				}

				public void surfaceDestroyed(SurfaceHolder holder) {
				}
			});
			videoViewHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
			videoView.setVisibility(View.INVISIBLE);
			new Thread(){public void run(){
				Arena.videoPlayer = new MediaPlayer();
				for(int i=0; i<3; i++){
					try {
						Arena.videoPlayer.setDisplay(STK.videoViewHolder);
						break;
					} catch (Exception e) {
						synchronized (this) {
							try {
								Thread.sleep(1000);
							} catch (Exception e1) { }
						}
					}
				}
				Arena.videoPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
				Arena.videoPlayer.setOnPreparedListener(new OnPreparedListener() { public void onPrepared(MediaPlayer mp) {
	            		Util.logInfo("Video start.");
	            		Arena.videoPlayer.start();
					}});
			}}.start();
		}
		for(int i=0; i<Util.getSysControls().size(); i++)
		{
			layout.addView(Util.getSysControls().get(i));
		}
		new Thread(){
			public void run()
			{
				while(!Arena.isInit);
				Arena.setScene(new Scene());
				Arena.start();
				perform();
			}
		}.start();
		isStarted=true;
	}

	@Override
	protected void onResume() {
		super.onResume();
		try {
			this.wakeLock.acquire();
        } catch (Exception e) { }
	}
	
	@Override
	protected void onPause() {
		super.onPause();
		try {
			this.wakeLock.release();
        } catch (Exception e) { } 
	}

	@Override
	protected void onStop()
	{
		super.onStop();
		if(isStarted)
		{
			Arena.shutdown();
			System.exit(0);
		}
	}

	@Override
	public final boolean onKeyDown(final int keyCode, final KeyEvent event)
	{
		Arena.moving = false;
		if(keysPressed.contains(keyCode))
		{
			return true;
		}
		else
		{
			if(keysPressed.size()==3)
				keysPressed.remove(0);
			keysPressed.add(keyCode);
		}
		Util.logInfo("Key ["+keyCode+"] down");
		new Thread()
		{
			public void run()
			{
				keyDownResult=onKeyDown(keyCode);
				synchronized (this) {
					while(keysPressed.contains(keyCode)) {
						keyDownResult=onKeyLongPress(keyCode);
						try {
							Thread.sleep(1000/Util.getMaxFPS());
						} catch (Exception e) { }
					}
				}
			}
		}.start();
		
		if(keyDownResult)
		{
			keyDownResult=false;
			return true;
		}
		else
		{
			return false;
		}
	}
	
	@Override
	public boolean onKeyUp(final int keyCode, KeyEvent event)
	{
		keysPressed.remove((Integer)(keyCode));
		Util.logInfo("Key ["+keyCode+"] up");
		new Thread()
		{
			public void run()
			{
				onKeyUp(keyCode);
			}
		}.start();
		return false;
	}

	void removePressedKey(int keyCode)
	{
		keysPressed.remove((Integer)keyCode);
	}

	private boolean onKeyDown(int keyCode)
	{
		if (Arena.refuseList.size() > 0)
		{
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("\n[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
			return false;
		}
		else
		{
			Scene scene = Arena.getScene();
			if(scene==null)
				return false;
			Panel panel = scene.getPanel();
			if(panel!=null)
				return panel.onKeyDown(keyCode);
			else
				return scene.onKeyDown(keyCode);
		}
	}
	
	private boolean onKeyLongPress(int keyCode)
	{
		if (Arena.refuseList.size() > 0)
		{
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("\n[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
			return false;
		}
		else
		{
			Scene scene = Arena.getScene();
			if(scene==null)
				return false;
			Panel panel = scene.getPanel();
			if(panel!=null)
				return panel.onKeyLongPress(keyCode);
			else
				return scene.onKeyLongPress(keyCode);
		}
	}

	private boolean onKeyUp(int keyCode)
	{
		if (Arena.refuseList.size() > 0)
		{
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("\n[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
		}
		else
		{
			Scene scene = Arena.getScene();
			if(scene==null)
				return false;
			Panel panel = scene.getPanel();
			if(panel!=null)
				panel.onKeyUp(keyCode);
			else
				scene.onKeyUp(keyCode);
		}
		return true;
	}

	@Override
	public boolean onTouchEvent(final MotionEvent event)
	{
		if(Arena.getScene()==null)
			return false;
		final int x = (int)(event.getX())+touchRelaX;
		final int y = (int)(event.getY())+touchRelaY;
		switch(event.getAction())
		{
			case MotionEvent.ACTION_DOWN:
				Util.logInfo("Touch screen on [" + x + "," + y + "].");
				if(Arena.moving)
					return true;
				onScreenDown(x, y);
				break;
			case MotionEvent.ACTION_UP:
				if(Arena.moving){
					Arena.moving=false;
					return true;
				}
				new Thread(){public void run(){
					onScreenUp(x, y);
				}}.start();
				break;
			case MotionEvent.ACTION_MOVE:
				if(Arena.moving)
					return true;
				onScreenMove(x, y);
				break;
		}
		
		return true;
	}

	private boolean onScreenDown(final int x, final int y) {
		if (Arena.refuseList.size() > 0) {
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
		} else {
			ArrayList<OperationalControl> ctrls = Arena.getScene().getOperationalControls();
			for(int i=ctrls.size()-1; i>-1; i--){
				if(ctrls.get(i).onTouch(x, y))
					break;
				if(ctrls.get(i) instanceof Button) {
					int keyCode=((Button)ctrls.get(i)).getKeyCode();
					if(keyCode!=-1)
						onKeyDown(keyCode);
				}
			}
//			for(final OperationalControl control : Arena.getScene().getOperationalControls()){
//				if(control.onTouch(x, y))
//					break;
//				if(control instanceof Button) {
//					int keyCode=((Button)control).getKeyCode();
//					if(keyCode!=-1)
//						onKeyDown(keyCode);
//				}
//			}
			if(Arena.getScene().getOperationalControls().size()==0)
				Arena.getScene().onUserTouchScreen(x, y);
		}
		return true;
	}

	private boolean onScreenUp(final int x, final int y)
	{
		Util.logInfo("Release screen on [" + x + "," + y + "].");
		if (Arena.refuseList.size() > 0)
		{
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
		} else {
			ArrayList<OperationalControl> ctrls = Arena.getScene().getOperationalControls();
			for(int i=ctrls.size()-1; i>-1; i--){
				if(ctrls.get(i).onRelease(x, y))
					break;
			}
//			for(final OperationalControl control : Arena.getScene().getOperationalControls()){
//				if(control.onRelease(x, y))
//					break;
//			}
			if(Arena.getScene().getOperationalControls().size()==0)
				Arena.getScene().onUserReleaseScreen(x, y);
		}
		return true;
	}

	private synchronized boolean onScreenMove(final int x, final int y)
	{
		if (Arena.refuseList.size() > 0) {
			StringBuilder msg = new StringBuilder("Input being refused by ");
			for (int i = 0; i < Arena.refuseList.size(); i++)
				msg.append("[" + Arena.refuseList.get(i) + "] ");
			Util.logInfo(msg.toString());
			msg.delete(0, msg.length());
			msg = null;
			return false;
		}
		ArrayList<OperationalControl> ctrls = Arena.getScene().getOperationalControls();
		for(int i=ctrls.size()-1; i>-1; i--){
			final OperationalControl ctrl = ctrls.get(i);
			if(ctrl.getStatus()==Status.DOWN){
				new Thread() { public void run() {
					ctrl.onDrag(x, y);
				}}.start();
			}
		}
//		for(final OperationalControl control : Arena.getScene().getOperationalControls()){
//			if(control.getStatus()==Status.DOWN)
//				new Thread() { public void run() {
//					control.onDrag(x, y);
//				}}.start();
//		}
		if(Arena.getScene().getOperationalControls().size()==0)
			Arena.getScene().onUserMoveScreen(x, y);
		return true;
	}


	/**
	 * 游戏即将关闭时发生的事件
	 * @return false则取消关闭动作
	 */
	public boolean onExit()
	{
		return true;
	}

}
