package wafly.framework.storyTK.ai.action;

import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.IaiAction;

/**
 * 使拥有此AI的精灵向着指定坐标移动，只是大概值，误差范围在站立范围之内
 * AI.x=ai判断 [参数1] [参数2] ...
 * AI.ACT.x=wafly.framework.storyTK.ai.action.MoveToPoint x y
 * @author Wafly
 */
public class MoveToPoint implements IaiAction {

	@Override
	public void onAction(Sprite aiOwner, String[] args) {
		if(args.length<3){
			Util.logError("Params [x] and [y] for AI [MoveToPoint] is required.", null);
			return;
		}
		aiOwner.stopMoving();
		int x=0, y=0;
		try{
			x=Integer.parseInt(args[1]);
			y=Integer.parseInt(args[2]);
		}catch(Exception e){
			Util.logError("Params [x] or [y] for AI [MoveToPoint] not number format.", null);
			return;
		}
		while(Math.abs(aiOwner.getX()+aiOwner.getStandAreaPositionX()-x)
				+ Math.abs(aiOwner.getY()+aiOwner.getStandAreaPositionY()-y)
				> aiOwner.getScene().getStandSize()*2.42){
			if(aiOwner.isMoving())
				continue;
			if(aiOwner.getX()+aiOwner.getStandAreaPositionX()-aiOwner.getScene().getStandSize() < x
					&& aiOwner.getX()+aiOwner.getStandAreaPositionX()+aiOwner.getScene().getStandSize() > x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < y){
				aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX()-aiOwner.getScene().getStandSize() < x
					&& aiOwner.getX()+aiOwner.getStandAreaPositionX()+aiOwner.getScene().getStandSize() > x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > y){
				aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY()-aiOwner.getScene().getStandSize() < y
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY()+aiOwner.getScene().getStandSize() > y){
				aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY()-aiOwner.getScene().getStandSize() < y
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY()+aiOwner.getScene().getStandSize() > y){
				aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < y){
				if(aiOwner.verifyDirection(6)>-1)
					aiOwner.move(new int[]{6,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(1)>-1)
					aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < y){
				if(aiOwner.verifyDirection(5)>-1)
					aiOwner.move(new int[]{5,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(1)>-1)
					aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > y){
				if(aiOwner.verifyDirection(8)>-1)
					aiOwner.move(new int[]{8,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(4)>-1)
					aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > x
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > y){
				if(aiOwner.verifyDirection(7)>-1)
					aiOwner.move(new int[]{7,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(4)>-1)
					aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}
		}
	}

}
