package wafly.framework.storyTK.ai.action;

import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.IaiAction;

/**
 * 使拥有此AI的精灵向着指定精灵移动
 * AI.x=ai判断 [参数1] [参数2] ...
 * AI.ACT.x=wafly.framework.storyTK.ai.action.MoveToSprite 精灵ID
 * @author Wafly
 */
public class MoveToSprite implements IaiAction {

	@Override
	public void onAction(Sprite aiOwner, String[] args) {
		if(args.length<2){
			Util.logError("Param [SpriteID] for AI [MoveToSprite] is required.", null);
			return;
		}
		Sprite moveTargetSprite = aiOwner.getScene().getSprite(args[1]);
		if(moveTargetSprite==null){
			Util.logError("Sprite with ID ["+args[1]+"] not found", null);
			return;
		}
		aiOwner.stopMoving();
		while(Math.abs(aiOwner.getX()+aiOwner.getStandAreaPositionX()-moveTargetSprite.getX()-moveTargetSprite.getStandAreaPositionX())
				+ Math.abs(aiOwner.getY()+aiOwner.getStandAreaPositionY()-moveTargetSprite.getY()-moveTargetSprite.getStandAreaPositionY())
				> aiOwner.getScene().getStandSize()*2.42){
			if(aiOwner.isMoving())
				continue;
			if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()-aiOwner.getScene().getStandSize()
					&& aiOwner.getX()+aiOwner.getStandAreaPositionX() < moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()+aiOwner.getScene().getStandSize()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()-aiOwner.getScene().getStandSize()
					&& aiOwner.getX()+aiOwner.getStandAreaPositionX() < moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()+aiOwner.getScene().getStandSize()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()-aiOwner.getScene().getStandSize()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()+aiOwner.getScene().getStandSize()){
				aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()-aiOwner.getScene().getStandSize()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()+aiOwner.getScene().getStandSize()){
				aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				if(aiOwner.verifyDirection(6)>-1)
					aiOwner.move(new int[]{6,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(1)>-1)
					aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() < moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				if(aiOwner.verifyDirection(5)>-1)
					aiOwner.move(new int[]{5,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(1)>-1)
					aiOwner.move(new int[]{1,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() < moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				if(aiOwner.verifyDirection(8)>-1)
					aiOwner.move(new int[]{8,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(4)>-1)
					aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{3,aiOwner.getScene().getStandSize()}, false);
			}else if(aiOwner.getX()+aiOwner.getStandAreaPositionX() > moveTargetSprite.getX()+moveTargetSprite.getStandAreaPositionX()
					&& aiOwner.getY()+aiOwner.getStandAreaPositionY() > moveTargetSprite.getY()+moveTargetSprite.getStandAreaPositionY()){
				if(aiOwner.verifyDirection(7)>-1)
					aiOwner.move(new int[]{7,aiOwner.getScene().getStandSize()}, false);
				else if(aiOwner.verifyDirection(4)>-1)
					aiOwner.move(new int[]{4,aiOwner.getScene().getStandSize()}, false);
				else
					aiOwner.move(new int[]{2,aiOwner.getScene().getStandSize()}, false);
			}
		}
	}

}
