package wafly.framework.storyTK.ai.judge;

import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.IaiJudge;

/**
 * 判断拥有此AI的精灵是否靠近了指定的精灵的指定范围内
 * AI.x=wafly.framework.storyTK.ai.judge.IfCloseTo 精灵ID 生效距离
 * AI.ACT.x=ai行为 [参数1] [参数2] ...
 * @author Wafly
 */
public class IfCloseTo implements IaiJudge {

	@Override
	public boolean onJudge(Sprite aiOwner, String[] args) {
		if(args.length<3){
			Util.logError("Params [SpriteID] and [distance] for AI [IfCloseTo] is required.", null);
			return false;
		}
		Sprite moveTargetSprite = aiOwner.getScene().getSprite(args[1]);
		if(moveTargetSprite==null){
			Util.logError("Sprite with ID ["+args[1]+"] not found", null);
			return false;
		}
		int distance = 0;
		try {
			distance = Integer.parseInt(args[2]);
		} catch (Exception e) {
			Util.logError("Distace ["+args[1]+"] not number format", null);
			return false;
		}
		return (Math.abs(aiOwner.getX()+aiOwner.getStandAreaPositionX()-moveTargetSprite.getX()-moveTargetSprite.getStandAreaPositionX())
				+ Math.abs(aiOwner.getY()+aiOwner.getStandAreaPositionY()-moveTargetSprite.getY()-moveTargetSprite.getStandAreaPositionY())
				< aiOwner.getScene().getStandSize()*2.42+distance);
	}

}
