package wafly.framework.storyTK.component.hit;

import wafly.framework.storyTK.control.FrameAnimation;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.Hit;

/**
 * 近身打击动作
 * @author Wafly
 */
public class CloseHit extends Hit {
	
	private FrameAnimation actionFrame = null;

	public CloseHit(Sprite actOwner, FrameAnimation actionFrame) {
		super(actOwner);
		this.actionFrame=actionFrame;
	}

	@Override
	protected Sprite[] getHitTargetSprites(Sprite actionOwner, int hitAreaLeft, int hitAreaTop, int hitAreaWidth, int hitAreaHeight) {
		switch(getActionOwner().getCurrentDirection()){
		case 1:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX(),
					getActionOwner().getStandAreaPositionY()+getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		case 2:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()-getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY(),
					getActionOwner()).toArray(new Sprite[0]);
		case 3:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()+getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY(),
					getActionOwner()).toArray(new Sprite[0]);
		case 4:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX(),
					getActionOwner().getStandAreaPositionY()-getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		case 5:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()-getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY()+getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		case 6:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()+getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY()+getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		case 7:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()-getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY()-getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		case 8:
			return getActionOwner().getScene().getCollideSprites(
					getActionOwner().getStandAreaPositionX()+getActionOwner().getScene().getStandSize(),
					getActionOwner().getStandAreaPositionY()-getActionOwner().getScene().getStandSize(),
					getActionOwner()).toArray(new Sprite[0]);
		}
		return null;
	}

	@Override
	protected TargetPoint getHitTargetPoint(Sprite actionOwner) {
		return null;
	}

	@Override
	protected FrameAnimation getOwnerPerformentsFrame() {
		actionFrame.setLocation(getActionOwner().getX(), getActionOwner().getY());
		return actionFrame;
	}

	@Override
	public void destroy() {
		super.destroy();
		if(actionFrame!=null)
			actionFrame.destroy();
	}

}
