package wafly.framework.storyTK.component.hit;

import java.util.ArrayList;

import wafly.framework.storyTK.control.FrameAnimation;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.Hit;

public class MapHit extends Hit {

	private FrameAnimation ownerActionFrame = null;
	
	public MapHit(Sprite actOwner, FrameAnimation ownerActionFrame, FrameAnimation mapAction, long effectiveDelay) {
		super(actOwner);
		this.ownerActionFrame=ownerActionFrame;
		setMapHit(mapAction, effectiveDelay);
	}

	@Override
	protected Sprite[] getHitTargetSprites(Sprite actionOwner, int hitAreaLeft, int hitAreaTop, int hitAreaWidth, int hitAreaHeight) {
		ArrayList<Sprite> spList = getActionOwner().getScene().getAllSprites();
		ArrayList<Sprite> beHitSpList = new ArrayList<Sprite>();
		for(Sprite sp:spList){
			if(sp.getStandAreaPositionX()+sp.getScene().getStandSize()>hitAreaLeft
					&& sp.getStandAreaPositionX()-sp.getScene().getStandSize()<hitAreaLeft+hitAreaWidth
					&& sp.getStandAreaPositionY()+sp.getScene().getStandSize()>hitAreaTop
					&& sp.getStandAreaPositionY()-sp.getScene().getStandSize()<hitAreaTop+hitAreaHeight)
				beHitSpList.add(sp);
		}
		return beHitSpList.toArray(new Sprite[0]);
	}

	@Override
	protected TargetPoint getHitTargetPoint(Sprite actionOwner) {
		return null;
	}

	@Override
	protected FrameAnimation getOwnerPerformentsFrame() {
		ownerActionFrame.setLocation(getActionOwner().getX(), getActionOwner().getY());
		return ownerActionFrame;
	}

}
