package wafly.framework.storyTK.component.hit;

import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.component.TrackAnimation;
import wafly.framework.storyTK.control.FrameAnimation;
import wafly.framework.storyTK.control.Sprite;
import wafly.framework.storyTK.tmpl.Hit;

public class RemoteHit extends Hit {

	private FrameAnimation ownerActionFrame = null;
	private TargetPoint tp = new TargetPoint(0, 0);

	public RemoteHit(Sprite actOwner, FrameAnimation ownerActionFrame, TrackAnimation remoteAction) {
		super(actOwner);
		this.ownerActionFrame=ownerActionFrame;
		setTrackHit(remoteAction);
	}

	@Override
	protected Sprite[] getHitTargetSprites(Sprite actionOwner, int hitAreaLeft, int hitAreaTop, int hitAreaWidth, int hitAreaHeight) {
		return null;
	}

	@Override
	protected TargetPoint getHitTargetPoint(Sprite actionOwner) {
		return tp;
	}

	@Override
	protected FrameAnimation getOwnerPerformentsFrame() {
		ownerActionFrame.setLocation(getActionOwner().getX(), getActionOwner().getY());
		return ownerActionFrame;
	}

	@Override
	public void takeAction() {
		Util.logError("Use takeAction(int x, int y) to take action", null);
	}
	
	public void takeAction(int x, int y){
		tp.x=x;
		tp.y=y;
		super.takeAction();
	}

}
