package wafly.framework.storyTK.control;

import wafly.framework.storyTK.basic.DrawableHelper;
import wafly.framework.storyTK.basic.StoreMgr;
import wafly.framework.storyTK.basic.Util;
import wafly.framework.storyTK.tmpl.Control;

/**
 * 用于显示一幅图片的容器<br>
 * 默认动作：无
 * @author Wafly
 *
 */
public class PictureBox extends Control
{
	private DrawableHelper image = null;
	
	public PictureBox(DrawableHelper image)
	{
		if(image==null)
			this.image=new DrawableHelper(1, 1);
		else
			this.image=image;
		this.width=this.image.getWidth();
		this.height=this.image.getHeight();
	}
	
	public PictureBox(long id, StoreMgr storeMgr)
	{
		super(id, storeMgr);
		image = DrawableHelper.restoreValue("PICTUREBOX."+ID+".IMAGE", storeMgr);
		this.width=image.getWidth();
		this.height=image.getHeight();
	}
	
	/** 更换当前图片匣的图片 */
	public void setImage(DrawableHelper image)
	{
		this.image.destroy();
		if(image==null)
		{
			this.image=new DrawableHelper(1, 1);
			this.width=1;
			this.height=1;
		}
		else
		{
			this.image=image;
			this.width=image.getWidth();
			this.height=image.getHeight();
		}
	}
	
	/** 获取当前图片 */
	public DrawableHelper getImage(){
		return image;
	}
	
	/**
	 * 设置图片匣的大小，其中图片会随着缩放
	 * @param width
	 * @param height
	 */
	public void setSize(int width, int height)
	{
		this.width=width;
		this.height=height;
		image.zoomTo(width, height);
	}
	
	@Override
	public void onDraw(DrawableHelper draw)
	{
		if(!visible)
			return;
		int tAlpha = draw.getDrawAlpha();
		if (tAlpha != alpha)
			draw.setDrawAlpha(alpha);
		draw.drawImage(image, relaX + location_X, relaY + location_Y);
		if (tAlpha != alpha)
			draw.setDrawAlpha(tAlpha);
	}

	@Override
	public void storeValue(StoreMgr storeMgr)
	{
		super.storeValue(storeMgr);
		image.storeValue("PICTUREBOX."+ID+".IMAGE", storeMgr);
	}

	@Override
	public void destroy() {
		if(image!=null)
			image.destroy();
		Util.logInfo("PictureBox being destroyed.");
	}

}
