package wafly.framework.storyTK.scene.story;

import java.util.ArrayList;
import wafly.framework.storyTK.Panel;
import wafly.framework.storyTK.control.Button;
import wafly.framework.storyTK.listener.ActionListener;
import wafly.framework.storyTK.tmpl.Control;

public class SelectBox extends Panel {
	
	private DramaScene scene = null;

	public SelectBox(String backgroundFilePath) {
		super(backgroundFilePath);
	}
	
	public SelectBox(int width, int height, int color) {
		super(width, height, color);
	}
	
	public void setContainer(DramaScene container){
		this.scene=container;
	}
	
	public void setSelections(final SelectBean...selects){
		if(scene==null)
			return;
		ArrayList<Control> ctrls = getControls();
		for(Control oldCtrl : ctrls){
			oldCtrl.destroy();
		}
		getControls().clear();

		int height = getHeight()/selects.length;
		for(int i=0; i<selects.length; i++){
			final SelectBean select = selects[i];
			Button selectBtn = new Button(0,height,getWidth(),i*height);
			selectBtn.setText(select.getTitle());
			selectBtn.addActionListener(new ActionListener() { public void onPerform() {
				scene.loadDrama(select.getDramaPath());
				scene.setDramaLineIndex(0);
				scene.processNextLine();
				SelectBox.this.close();
			}});
			addControl(selectBtn);
		}
	}

}
