package wafly.framework.storyTK.tmpl;

/**
 * 继承这个接口可以实现Scene中发生的事件<br>
 * 如果通过属性文件来初始化一个事件,文件内容通常是这样的:<br><br>
 * <strong>#The first line should be blank as this properties file should be UTF-8#</strong><br>
 * <strong>CLS=event.class.package</strong><br>
 * <strong>ARGS=param of this event</strong><br><br>
 * 其中"#"开头的行表示注释. 文件中共有两个属性: CLS和ARGS<br>
 * CLS所指向的值表示事件类的完整路径(包和类名)<br>
 * ARGS所指向的值表示事件类中"takeAffect()"函数的参数<br><br>
 * 需要注意的是<br>
 * 1. CLS和ARGS均为大写<br>
 * 2. 文件编码格式建议是UTF-8<br>
 * 3. 文件第一行不要有内容(注释或留空)
 * @author Wafly
 */
public interface Ievent
{
	/**
	 * 事件的具体内容<br>
	 * the content of the event
	 * @param args 当使用事件属性文件来触发事件时,可以带一个字符串参数传入,否则若直接触发事件则参数总是为null<br>
	 *             if use event profile, there will take String param, or would be null
	 */
	public void takeAffect(String... args);
}



